#!/usr/bin/env python

# -*- coding: utf-8 -*-
#"""
#Created on Sat Nov  3 11:02:30 2018

#@author: Charles Escobar
#"""
#############################################################################
#  Gradio un programa de Automatización de radio programado en bash  #
#			  Última actualización: 04-Marzo-2018		    #
#############################################################################
#	     Projecto iniciado el 16 de junio de 2011	    		            #
#        Migración a python en nov 1 de 2018                                #
#############################################################################
#############################################################################
#                                                                           #
# This program is free software; you can redistribute it and/or modify it   #
# under the terms of the GNU General Public License as published by the     #
# Free Software Foundation; either version 2 of the License or any later    #
# version.								    #
#									    #
# This program is distributed in the hope that it will useful, but WITHOUT  #
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or     #
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     #
# for more details.							    #
#									    #
############################################################################# 
import datetime
import time
import os
import mplayer #sudo pip3 install mplayer.py
import ntpath 
from glob import glob
import random
from pathlib import Path #sudo pip3 install pathlib
import pandas as pd #sudo pip3 install pandas

pd.set_option('display.max_columns', None) 
pd.set_option('display.max_colwidth', -1)
HOME=os.environ['HOME']
salir=0

extensiones=open(HOME+'/.gradio/data/extensiones','r')
serie_ext=()
for  y in extensiones:
    y=y.replace("\n","")
    serie_ext=serie_ext+(y,)
print(serie_ext)

def add_playlist(randomfile,nombrebase,duracion=''):
        playlist_file=open(HOME+'/.gradio/data/tmp/playlist', 'a')
        playlist_file.write(randomfile+'\n')
        playlist_file.close()
        playlist_file=open(HOME+'/.gradio/data/tmp/playlistg3', 'a')
        playlist_file.write(nombrebase+' ['+duracion+']\n')
        playlist_file.close()
        return

def duracion_tema(tema):
    p=mplayer.Player()
    p.loadfile(tema)
    duracion_s=p.length
    #duracion=0
    try:
        duracion=str(datetime.timedelta(seconds=duracion_s))
        print(duracion)
    except:
        duracion='00:00:00'
        
    return duracion

def validar_ext(randomfile,serie_ext):
    if randomfile.lower().endswith(serie_ext):
        duracion=duracion_tema(randomfile)
        nombrebase=ntpath.basename(randomfile)
        playlist_file=open(HOME+'/.gradio/data/tmp/playlist', 'a')
        playlist_file.write(randomfile+'\n')
        playlist_file.close()
        playlist_file=open(HOME+'/.gradio/data/tmp/playlistg3', 'a')
        playlist_file.write(nombrebase+' ['+duracion+']\n')
        playlist_file.close()
        return
        
    else:
        print('el archivo: '+randomfile+' parece no ser de audio')

def tema_tocado(randomfile):
     randomfile=randomfile
     nombrebase=ntpath.basename(randomfile)
     nombredir=os.path.dirname(randomfile)
     ruta_mus = Path(nombredir+'/.historico.mus')
     if ruta_mus.is_file():
         control=open(nombredir+'/.historico.mus','r')
         serie_control=()
         for  y in control:
             y=y.replace("\n","")
             serie_control=serie_control+(y,)
         if nombrebase in serie_control:
             #tocado=True
             print(randomfile+' ya ha sido tocado vamos a buscar en esa carpeta')
             if os.path.isdir(nombredir):
                 print('es dir en nombredir')
                 temas=[y for x in os.walk(nombredir) for y in glob(os.path.join(x[0], '*.*'))]
                 serie_temas=()
                 for  u in temas:
                     u=u.replace(nombredir+'/',"")
                     serie_temas=serie_temas+(u,)
                 notocados=list(set(serie_temas)-set(serie_control))
                 if len(notocados) >= 1:
                     temas_random=random.randint(0,len(notocados)-1)
                     randomfile=notocados[temas_random]
                     randomfile=nombredir+'/'+randomfile
                     print('randomfile:'+randomfile)
                 else:
                     vaciar_file=open(nombredir+'/.historico.mus','w')
                     vaciar_file.close()
                     temas_random=random.randint(0,len(temas)-1)
                     randomfile=temas[temas_random]
                     print('randomfile:'+randomfile)                     
     return randomfile
         

while salir == 0:
    now = datetime.datetime.now()
    hora=now.hour
    dia=datetime.datetime.today().weekday()+1
    minuto=now.minute
    listatemas=14-1 #comienza en cero
    ranura=str(hora)+'-'+str(hora+1)+'.mus'
    parrilla=pd.read_csv(HOME+'/.gradio/data/parrilla/'+str(dia)+'/'+ranura, header=None)
    nlineas=parrilla.shape[0]
    hora1=hora 
    while hora == hora1:  #Xhile 2 de hora , Construye un playlis de n temas
        playlist_read=open(HOME+'/.gradio/data/tmp/playlist','r')
        #playlist_read=pd.read_csv(HOME+'/.gradio/data/tmp/playlist',header=None)
        #playlist=playlist_read.shape[0]
        playlist=len(playlist_read.readlines())
        while playlist < listatemas: #Xhile 3 playlist menor a 14 #######################################################################################3 #caracteres=`wc -m ~/.gradio/data/parrilla/$dia/$ranura|cut -d " " -f 1`
            if not parrilla.empty: 
                nlinea=0		
                while nlinea < nlineas: #Xhile 4 lineas de parrilla
                    print(nlinea)
                    line=parrilla.iloc[nlinea].to_string(index=False)
                    if hora==hora1:
                        ouch=0
                        if line == 'Hora': #fi4 Carga la hora o archivo o random
                            randomfile='Hora'
                            nombrebase='Hora'
                            add_playlist(randomfile,nombrebase)
                        elif os.path.isfile(line): #fi4 fi4 Carga la hora o archivo o random
                            print(line)
                            randomfile=line
                            validar_ext(randomfile,serie_ext)
    

                        else: #fi5 es directorio;
                            line=line.replace("*","")
                            print('line:'+line)
                            if os.path.isdir(line):
                                print('es dir')
                                temas=[y for x in os.walk(line) for y in glob(os.path.join(x[0], '*.*'))]
                                temas_len=len(temas)
                                temas_random=random.randint(0,temas_len-1)
                                randomfile=temas[temas_random]
                                print('randomfile:'+randomfile)
                                tema_tocado(randomfile)
                                validar_ext(randomfile,serie_ext)                                
                    nlinea+=1
            os.system(HOME+'/.gradio/bin/cartucho.sh')
            playlist_read=open(HOME+'/.gradio/data/tmp/playlist','r')
            playlist=len(playlist_read.readlines())
            time.sleep(3)/bin/cartucho.sh', shell=True)

            playlist_read=open(HOME+'/.gradio/data/tmp/playlist','r')
            playlist=len(playlist_read.readlines())

        time.sleep(1)


